
package netting;
import java.net.*;
import java.io.*;
public class MyServerSocket extends ServerSocket {
    public MyServerSocket(int port) throws IOException {
        super(port);
    }
    @Override
    public MySocket accept() throws IOException {
	if (isClosed())
	    throw new SocketException("MySocket is closed");
	if (!isBound())
	    throw new SocketException("MySocket is not bound yet");
	MySocket s = new MySocket((SocketImpl) null);
	implAccept(s);
	return s;
    }

}
