package netting;

import java.io.*;
import java.net.*;

public class Server1 extends Thread {

  protected ServerSocket ss;

  public Server1(int port) {
    try { ss = new ServerSocket(port); }
    catch (IOException e) { System.err.println(e ); System.exit(1);}
    System.out.println("Server on port " + port);
    this.start();
  }

  @Override
  public void run() {
    try {
      while(true) {
        Socket cs = ss.accept();   // blocking operation
        System.out.println("cs="+cs+"  "+cs.getClass());
        Clerk c = new Clerk(cs);
      }
    } catch (IOException e) { System.out.println(" "+e); }
  }

  public static void main(String[] args) {
    new Server1(6789);
  }

  // *****************************************

  static class Clerk extends Thread {
    static int count;
    static final int WILL=3;
    int ans=0;
    int id;
    protected Socket cs;
    protected BufferedReader in;
    protected PrintWriter out;

    // Initialize the streams and start the thread
    public Clerk(Socket cs) {
      this.cs=cs; id=++count;
      try {
        in = new BufferedReader(new InputStreamReader(cs.getInputStream()));
        out = new PrintWriter(cs.getOutputStream(),true /* autoFlush */ );
      }
      catch (IOException e) {
        try { cs.close(); } catch (IOException e2) {  }
        System.err.println("Exception while getting socket streams: " + e);
        return;
      }
      this.start();
      System.out.println("clerk id="+id+"    on port:"+cs.getPort() );
    }

    // Provide the service: Read a line, reverse it, send it back.
    @Override
    public void run() {
      String line;
      StringBuffer revline;
      int len;
      try {
        out.println("TADY OUREDNIK c."+id+" - CO CHCETE ?");
        line = in.readLine();
        System.out.println("clerk id="+id+"  "+line);
        for(int c=1; true; c++) {
          line = in.readLine();   // read in a line
          if (line==null) break;
          if (++ans>WILL) break;
          len = line.length();
//          if (line.startsWith("POST /") && line.endsWith(" HTTP/1.1")) {
//              line=line.substring(6, len-9);
//          }
//          else continue;
          revline = new StringBuffer(line).reverse();
          out.println(revline); // write reversed line
          System.out.println(c+ "  clerk id="+id+" : "+line+"->"+revline);
        }
      }
      catch (IOException e) {  }
      finally { try {cs.close();} catch (IOException e2) {} }
      System.out.println("clerk id="+id+"   finished");
    }
  }
}
