package netting;

import java.io.*;
import java.net.*;

public class Client  {
  public static final String ip ="127.0.0.1";   // "147.32.83.117";   //"10.21.1.1"; //;
  public static final int    port = 1111;
  static BufferedReader sin;

  public static void main(String[] args) throws Exception{

    Socket s = null;

    try {  
      System.out.println("creating socket");
      s = new Socket(ip, port);

      System.out.println("s="+s+"   "+s.getClass());

      sin = new BufferedReader(new InputStreamReader( s.getInputStream()));

      PrintWriter sout=new PrintWriter( s.getOutputStream(), true /* autoFlush */);

      BufferedReader in=new BufferedReader(new InputStreamReader(System.in));

      System.out.println("Connected to "+s.getInetAddress()+ ":"+ s.getPort());

      String line=sin.readLine();
      System.out.println(line);
      while(true) {
        System.out.println("> ");            // print a prompt
        System.out.flush();
        line = in.readLine();      // read a line
        if (line.equals("#")) break; // check for EOF
        sout.println(line);        // Send it to the server
        line = sin.readLine();     // Read a line from the server.
        if (line == null) {        // EOF
          System.out.println("Conn. closed by server.");
          break;
        }
        System.out.println(line);
      }
    }
    catch (IOException e) { System.err.println(e); }
    finally { // Always be sure to close the socket
      try { if (s != null) s.close(); } catch (IOException e2) { ; }
    }
  }
}
