
package netting;
import java.net.*;
import java.io.*;

public class Delivery0 {
    static String c1="BX0414424310X",
           u1="http://www.ceskaposta.cz/cz/nastroje/sledovani-zasilky.php"+
              "?barcode="+c1+
              "&locale=EN&go=ok";   
    
    static String c2="81021542559",
           u2="http://www.ppl.cz/main2.aspx?cls=Package&idSearch="+c2;
    
    
    public static void main(final String[] args) throws Exception {
       Pass  p=new PplPass(); 
       URL url=new URL(u2); 
       
       InputStream is=url.openStream();  
       BufferedReader br=new BufferedReader(new InputStreamReader(is));

       String s=c2;
       System.out.println("CODE="+s);
       while ( (s=br.readLine()) != null ) { 
           String x=p.filter(s);
           if(x!=null) System.out.println( x );
       } 
       
       if(p.getZ()==0) System.out.println("     NOT FOUND");
    }   
    
    
}

interface Pass {
    String filter(String in);
    void reset();
    int getZ();
}

class PplPass implements Pass {
    String start=">Status<", stop="</table>", first;
    int state=0, z=0;
    public String filter(String in) {        
        String f=in.trim();
       // System.out.println(state+"     "+f);

        switch (state) {
            case 0:
                if (f.contains(start)) {state=1; break; }
                else return null;
            case 1:
                if (f.contains(stop))  {state=2; return null; }
                else break;                
            case 2:
                return null;    
        }
        if(f.startsWith("<td>")) {
            int k=f.length();
            f=f.substring(4, k-5);
            if ( (z&1) == 0) { first=f; z++; return null; }
            else { z++; return first+"\t "+f; }
        }
        else return null;
    }
    
    public void reset() { state=0; z=0; }
    
    public int getZ() {return z;}
    
}


class CP_EN_Pass implements Pass {
    String start=">Information", stop="</table>";
    int state=0, z=0;
    boolean mk=false;
    public String filter(String in) {        
        String f=in.trim();
       // System.out.println(state+"     "+f);

        switch (state) {
            case 0:
                if (f.contains(start)) state=1; 
                return null;
            case 1:
                if (f.contains(stop))  {state=2; return null; }
                else break;                
            case 2:
                return null;    
        }
        if(mk) { mk=false; z++; return "     "+f; }
        if(f.startsWith("<td>")) mk=true; 
        return null;
    }
    
    public void reset() { state=0; z++;  mk=false; }
    
    public int getZ() {return z;}
    
}
