package netting;

//import java.io.*;
import java.net.*;

public class ReceiverUDP {
  static final int port = 6010;
  public static void main(String args[]) throws Exception  {
    byte[] buffer = new byte[1024];
    String s;

       System.out.println("Creating socket on the port:"+port);
    DatagramSocket socket = new DatagramSocket(port);
       System.out.println("Created: "+socket.getLocalSocketAddress());

    while(true) {

       // Bug workaround: create a new packet to receive data each time
       // through the loop.
       // If we create the packet outside of this loop, then it seems to
       // loose track of its buffer size, and incoming packets are truncated.

      DatagramPacket packet = new DatagramPacket(buffer, buffer.length);
      System.out.println("Waiting to receive");

      socket.receive(packet);     // wait to receive

      s = new String(buffer, 0, packet.getLength());

      System.out.println("received from " +packet.getAddress().getHostName()+":"
            +packet.getPort() + ": " + s);
    }
  }
}
